/* 
 * Copyright (C) 2002-2003 Trpaslik
 * Copyright (C) 2003-2004 createagaga
 * Copyright (C) 2002-2007 Petr Kozelka, PPK at czdc dot org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
			
#ifndef CHAT_CTRL_H
#define CHAT_CTRL_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TypedListViewCtrl.h"
#include "ImageDataObject.h"
#include "../client/Client.h"
#include "UserInfo.h"

#ifndef _RICHEDIT_VER
#define _RICHEDIT_VER 0x0300
#endif

#include <AtlCrack.h>

class UserInfo;

class ChatCtrl: public CRichEditCtrl {
public:
	ChatCtrl();
	virtual ~ChatCtrl();

	LRESULT OnRButtonDown(POINT pt);

	bool HitNick(POINT p, tstring &sNick, int &iBegin, int &iEnd);
	bool HitIP(POINT p, tstring &sIP, int &iBegin, int &iEnd);
	bool HitURL();
	bool GetAutoScroll();

	tstring LineFromPos(POINT p);

	void AdjustTextSize();
	void AppendText(const Identity& i, const tstring& sMyNick, const tstring& sTime, const tstring& sIP, const tstring& sMsg, CHARFORMAT2& cf, bool bUseEmo = true);
	void AppendText(const tstring&  sMyNick, const tstring&  sTime, const tstring& sMsg, CHARFORMAT2& cf, const tstring& sAuthor = Util::emptyStringT, int iAuthorLen = 0, bool isMe = false, bool bUseEmo = true);
	long AppendTextOnly(const tstring& sMyNick, const TCHAR *sText, TCHAR *sMsgLower, const size_t iTextLen, CHARFORMAT2& cf, bool bMyMess, bool bUrlOnEnd = false);
	void AppendStatusText(const tstring& sTime, tstring sMsg, CHARFORMAT2& cf);
	void EndRedrawAppendTextOnly();

	void GoToEnd();
	void ClearChat();
	void SetAutoScroll(bool boAutoScroll);
	void SetClient(Client * pClient);
	void SetTextStyleMyNick(CHARFORMAT2 ts) { WinUtil::m_TextStyleMyNick = ts; };
	
	static tstring sSelectedUser;
	static tstring sSelectedLine;
	static tstring sSelectedIP;
private:
    bool m_boAutoScroll;
    Client* client;
};


#endif // CHAT_CTRL_H
