/* 
 * Copyright (C) 2003-2007 Petr Kozelka, PPK at czdc dot org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef USERINFO_H
#define USERINFO_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../client/TaskQueue.h"

#include "TypedListViewCtrl.h"
#include "WinUtil.h"

struct UserTask : public Task {
	UserTask(const OnlineUser& ou) : user(ou.getUser()), identity(ou.getIdentity()) { }
	
	User::Ptr user;
	Identity identity;
};

enum {
	COLUMN_FIRST, 
	COLUMN_NICK = COLUMN_FIRST, 
	COLUMN_SHARED, 
	COLUMN_EXACT_SHARED, 
	COLUMN_DESCRIPTION, 
	COLUMN_TAG,
	COLUMN_CONNECTION, 
	COLUMN_EMAIL, 
	COLUMN_CLIENTID, 
	COLUMN_VERSION, 
	COLUMN_MODE, 
	COLUMN_HUBS, 
	COLUMN_SLOTS, 
	COLUMN_LIMITER, 
	COLUMN_IP, 
	COLUMN_LAST
};

class UserInfo : public UserInfoBase {
public:
	UserInfo(const UserTask& u, bool bUpdate = true);
	~UserInfo();
	
	const TCHAR* getText(int col) const;

	static int compareItems(const UserInfo* a, const UserInfo* b, int col);
	uint8_t imageIndex() {
		return WinUtil::getImage(identity);
	}

	bool update(const Identity& identity, int sortCol);

	string getNick() const { return identity.getNick(); }

	GETSET(Identity, identity, Identity);
private:
	TCHAR* columns[COLUMN_LAST];
};

#endif //USERINFO_H